Index: sansview/perspectives/fitting/basepage.py
===================================================================
--- sansview/perspectives/fitting/basepage.py	(revision 9466f2d6a8ec770363ff314de3d4768470b1a6f6)
+++ sansview/perspectives/fitting/basepage.py	(revision 22963162e77a658f5b9affbe8d77c9cda810b0a3)
@@ -158,4 +158,7 @@
         #self.onSave(event=None)
         self.Bind(wx.EVT_CONTEXT_MENU, self.onContextMenu)
+        
+        # bind key event
+        self.Bind(wx.EVT_LEFT_DOWN, self.on_left_down)
 
         ## create the basic structure of the panel with empty sizer
@@ -427,5 +430,9 @@
                                             style=wx.RB_GROUP)
         self.enable_disp = wx.RadioButton(self, -1, 'On', (10, 30))
-       
+
+        self.disp_help_bt = wx.Button(self,wx.NewId(),'?', size=(20,15))
+        self.disp_help_bt.Bind(wx.EVT_BUTTON, 
+                        self.on_pd_help_clicked,id= self.disp_help_bt.GetId())
+        self.disp_help_bt.SetToolTipString("Helps for Polydispersion.")       
         
         self.Bind(wx.EVT_RADIOBUTTON, self._set_dipers_Param,
@@ -442,33 +449,14 @@
         sizer_dispersion.Add((20,20))
         sizer_dispersion.Add(self.disable_disp )
-        sizer_dispersion.Add((10,10))
-        
-        ## fill a sizer with the combobox to select dispersion type
-        sizer_select_dispers = wx.BoxSizer(wx.HORIZONTAL)  
-        self.model_disp = wx.StaticText(self, -1, 'Distribution Function ')
-            
-        import sans.models.dispersion_models 
-        self.polydisp= sans.models.dispersion_models.models
-        self.disp_box = wx.ComboBox(self, -1)
-
-        for key, value in self.polydisp.iteritems():
-            name = str(key)
-            self.disp_box.Append(name,value)
-        self.disp_box.SetStringSelection("gaussian") 
-        wx.EVT_COMBOBOX(self.disp_box,-1, self._on_select_Disp) 
-             
-        sizer_select_dispers.Add((10,10)) 
-        sizer_select_dispers.Add(self.model_disp) 
-        sizer_select_dispers.Add(self.disp_box,0,
-                wx.TOP|wx.BOTTOM|wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE,border=5)
-      
-        self.model_disp.Hide()
-        self.disp_box.Hide()
-        
+        sizer_dispersion.Add((25,20))
+        sizer_dispersion.Add(self.disp_help_bt)
+        
+        ## fill a sizer for dispersion         
         boxsizer1.Add( sizer_dispersion,0,
                 wx.TOP|wx.BOTTOM|wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE,border=5)
         #boxsizer1.Add( (10,10) )
-        boxsizer1.Add( sizer_select_dispers )
-        self.sizer4_4 = wx.GridBagSizer(5,5)
+        #boxsizer1.Add( sizer_select_dispers )
+        self.sizer4_4 = wx.GridBagSizer(6,5)
+
         boxsizer1.Add( self.sizer4_4  )
         #-----------------------------------------------------
@@ -484,106 +472,4 @@
         self.SetupScrolling()
 
-    def select_disp_angle(self, event): 
-        """
-        Event for when a user select a parameter to average over.
-        
-        :param event: radiobutton event
-        
-        """
-        self.values=[]
-        self.weights=[]
-        if event.GetEventObject()==self.noDisper_rbox:
-            if self.noDisper_rbox.GetValue():
-                #No array dispersity apply yet
-                self._reset_dispersity()
-                ## Redraw the model ???
-                self._draw_model()
-        # Go through the list of dispersion check boxes to identify
-        # which one has changed 
-        for p in self.disp_cb_dict:
-            self.state.disp_cb_dict[p]=  self.disp_cb_dict[p].GetValue()
-            # Catch which one of the box was just checked or unchecked.
-            if event.GetEventObject() == self.disp_cb_dict[p]:              
-                if self.disp_cb_dict[p].GetValue() == True:
-                    
-                    ##Temp. FIX for V1.0 regarding changing checkbox 
-                    #to radiobutton.
-                    ##This (self._reset_dispersity) should be removed 
-                    #when the array dispersion is fixed.                
-                    self._reset_dispersity()
-
-                    # The user wants this parameter to be averaged. 
-                    # Pop up the file selection dialog.
-                    path = self._selectDlg()
-                    
-                    # If nothing was selected, just return
-                    if path is None:
-                        self.disp_cb_dict[p].SetValue(False)
-                        self.noDisper_rbox.SetValue(True)
-                        return
-                    try:
-                        self._default_save_location = os.path.dirname(path)
-                    except:
-                        pass 
-                    try:
-                        self.values,self.weights = self.read_file(path)
-                    except:
-                        msg="Could not read input file"
-                        wx.PostEvent(self.parent.parent, 
-                                     StatusEvent(status=msg))
-                        return
-                    
-                    # If any of the two arrays is empty, notify the user that we won't
-                    # proceed 
-                    if self.values is None or self.weights is None or \
-                         self.values ==[] or self.weights ==[]:
-                        msg = "The loaded %s distrubtion is"
-                        msg + " corrupted or empty" % p
-                        wx.PostEvent(self.parent.parent, 
-                                     StatusEvent(status=msg))
-                        return
-                        
-                    # Tell the user that we are about to apply the distribution
-                    msg = "Applying loaded %s distribution: %s" % (p, path)
-                    wx.PostEvent(self.parent.parent, StatusEvent(status=msg))  
-                    
-                    # Create the dispersion objects
-                    from sans.models.dispersion_models import ArrayDispersion
-                    disp_model = ArrayDispersion()
-                    disp_model.set_weights(self.values, self.weights)
-                   
-                    # Store the object to make it persist outside the
-                    # scope of this method
-                    #TODO: refactor model to clean this up?
-                    self._disp_obj_dict[p] = disp_model
-                    self.state._disp_obj_dict [p]= disp_model
-                    self.state.values = []
-                    self.state.weights = []
-                    self.state.values = copy.deepcopy(self.values)
-                    self.state.weights = copy.deepcopy(self.weights)
-                    # Set the new model as the dispersion object for the 
-                    #selected parameter
-                    self.model.set_dispersion(p, disp_model)
-                    # Store a reference to the weights in the model object 
-                    #so that
-                    # it's not lost when we use the model within another thread.
-                    #TODO: total hack - fix this
-                    self.state.model= self.model.clone()
-
-                    self.model._persistency_dict = {}
-                    self.model._persistency_dict[p] = \
-                                                    [self.values, self.weights]
-                    self.state.model._persistency_dict[p] = \
-                                                    [self.values,self.weights]
-                else:
-                    self._reset_dispersity()
-              
-                ## Redraw the model
-                self._draw_model()
-        
-        ## post state to fit panel
-        event = PageInfoEvent(page = self)
-        wx.PostEvent(self.parent, event)
-       
     
     def onResetModel(self, event):
@@ -603,5 +489,16 @@
             previous_state = self.saved_states[name]
             ## reset state of checkbox,textcrtl  and  regular parameters value
-            self.reset_page(previous_state)      
+            self.reset_page(previous_state)   
+               
+    def on_report_state(self, event):
+        """
+        Report the current fit results
+        """   
+        event.Skip()
+        # Get plot image from plotpanel
+        images, canvases = self.get_images()
+        # get the report dialog
+        self.state.report(images, canvases)
+        
          
     def on_save(self, event):   
@@ -785,14 +682,4 @@
         self.state.qmax_x = self.qmax_x
         self.state.qmin_x = self.qmin_x
-        try:
-            n = self.disp_box.GetCurrentSelection()
-            dispersity= self.disp_box.GetClientData(n)
-            name= dispersity.__name__
-            self.disp_name = name
-            if name == "GaussianDispersion" :
-               if hasattr(self,"cb1"):
-                   self.state.cb1= self.cb1.GetValue()
-        except:
-            pass
       
         if hasattr(self,"enable_disp"):
@@ -811,22 +698,7 @@
         self.state.slit_smearer = copy.deepcopy(self.slit_smearer.GetValue())  
                   
-        if hasattr(self,"disp_box"):
-            self.state.disp_box = self.disp_box.GetSelection()
-
-            if len(self.disp_cb_dict)>0:
-                for k , v in self.disp_cb_dict.iteritems():
-         
-                    if v ==None :
-                        self.state.disp_cb_dict[k]= v
-                    else:
-                        try:
-                            self.state.disp_cb_dict[k]=v.GetValue()
-                        except:
-                            self.state.disp_cb_dict[k]= None
-           
-            if len(self._disp_obj_dict)>0:
-                for k , v in self._disp_obj_dict.iteritems():
-      
-                    self.state._disp_obj_dict[k]= v
+        if len(self._disp_obj_dict)>0:
+            for k , v in self._disp_obj_dict.iteritems():
+                self.state._disp_obj_dict[k]= v
                         
             
@@ -836,12 +708,15 @@
         self._save_plotting_range()
         
-        self.state.orientation_params =[]
-        self.state.orientation_params_disp =[]
-        self.state.parameters =[]
-        self.state.fittable_param =[]
-        self.state.fixed_param =[]
+        self.state.orientation_params = []
+        self.state.orientation_params_disp = []
+        self.state.parameters = []
+        self.state.fittable_param = []
+        self.state.fixed_param = []
+        self.state.str_parameters = []
 
         
         ## save checkbutton state and txtcrtl values
+        self._copy_parameters_state(self.str_parameters, 
+                                    self.state.str_parameters)
         self._copy_parameters_state(self.orientation_params,
                                      self.state.orientation_params)
@@ -873,15 +748,4 @@
         ## save data    
         self.state.data= copy.deepcopy(self.data)
-        try:
-            n = self.disp_box.GetCurrentSelection()
-            dispersity= self.disp_box.GetClientData(n)
-            name= dispersity.__name__
-            self.disp_name = name
-            if name == "GaussianDispersion" :
-               if hasattr(self,"cb1"):
-                   self.state.cb1= self.cb1.GetValue()
-
-        except:
-            pass
         
         if hasattr(self,"enable_disp"):
@@ -1065,5 +929,5 @@
             #self._undo.Enable(False)
             return 
-    
+        # set data, etc. from the state
         self.set_data(state.data)
         self.enable2D= state.enable2D
@@ -1108,52 +972,9 @@
         self.enable_disp.SetValue(state.enable_disp)
         self.disable_disp.SetValue(state.disable_disp)
-        
-        if hasattr(self, "disp_box"):
-            
-            self.disp_box.SetSelection(state.disp_box) 
-            n= self.disp_box.GetCurrentSelection()
-            dispersity= self.disp_box.GetClientData(n)
-            name = dispersity.__name__     
-
+        # If the polydispersion is ON
+        if state.enable_disp:
+            # reset dispersion according the state
             self._set_dipers_Param(event=None)
-       
-            if name == "ArrayDispersion":
-                
-                for item in self.disp_cb_dict.keys():
-                    
-                    if hasattr(self.disp_cb_dict[item], "SetValue") :
-                        self.disp_cb_dict[item].SetValue(\
-                                                    state.disp_cb_dict[item])
-                        # Create the dispersion objects
-                        from sans.models.dispersion_models import ArrayDispersion
-                        disp_model = ArrayDispersion()
-                        if hasattr(state,"values")and\
-                                 self.disp_cb_dict[item].GetValue() == True:
-                            if len(state.values)>0:
-                                self.values=state.values
-                                self.weights=state.weights
-                                disp_model.set_weights(self.values,
-                                                        state.weights)
-                            else:
-                                self._reset_dispersity()
-                        
-                        self._disp_obj_dict[item] = disp_model
-                        # Set the new model as the dispersion object 
-                        #for the selected parameter
-                        self.model.set_dispersion(item, disp_model)
-                    
-                        self.model._persistency_dict[item] = \
-                                                [state.values, state.weights]
-                    
-            else:
-                keys = self.model.getParamList()
-                for item in keys:
-                    if item in self.disp_list and \
-                        not self.model.details.has_key(item):
-                        self.model.details[item] = ["", None, None]
-                for k,v in self.state.disp_cb_dict.iteritems():
-                    self.disp_cb_dict = copy.deepcopy(state.disp_cb_dict) 
-                    self.state.disp_cb_dict = copy.deepcopy(state.disp_cb_dict)
-
+            self._reset_page_disp_helper(state)
         ##plotting range restore    
         self._reset_plotting_range(state)
@@ -1185,140 +1006,71 @@
         self.state = state.clone() 
     
-        
-    def old_reset_page_helper(self, state):
-        """
-        Use page_state and change the state of existing page
-        
-        :precondition: the page is already drawn or created
-        
-        :postcondition: the state of the underlying data change as well as the
-            state of the graphic interface
-        """
-        if state ==None:
-            #self._undo.Enable(False)
-            return 
-       
-        self.model= state.model
-        self.data = state.data
-        if self.data !=None:
-            from DataLoader.qsmearing import smear_selection
-            self.smearer= smear_selection(self.data, self.model)
-        self.enable2D= state.enable2D
-        self.engine_type = state.engine_type
-
-        self.disp_cb_dict = state.disp_cb_dict
-        self.disp_list = state.disp_list
-
-        ## set the state of the radio box
-        self.shape_rbutton.SetValue(state.shape_rbutton )
-        self.shape_indep_rbutton.SetValue(state.shape_indep_rbutton)
-        self.struct_rbutton.SetValue(state.struct_rbutton )
-        self.plugin_rbutton.SetValue(state.plugin_rbutton)
-        ##draw sizer containing model parameters value for the current model
-        self._set_model_sizer_selection( self.model )
-        self.set_model_param_sizer(self.model)
-
-        ## reset value of combox box
-        self.structurebox.SetSelection(state.structurecombobox )
-        self.formfactorbox.SetSelection(state.formfactorcombobox)
-        
-        
-        ## enable the view 2d button if this is a modelpage type
-        if hasattr(self,"model_view"):
-            if self.enable2D:
-                self.model_view.Disable()
+    def _reset_page_disp_helper(self, state):
+        """
+        Help to rest page for dispersions
+        """
+        keys = self.model.getParamList()
+        for item in keys:
+            if item in self.disp_list and \
+                not self.model.details.has_key(item):
+                self.model.details[item] = ["", None, None]
+        #for k,v in self.state.disp_cb_dict.iteritems():
+        self.disp_cb_dict = copy.deepcopy(state.disp_cb_dict) 
+        self.state.disp_cb_dict = copy.deepcopy(state.disp_cb_dict)
+        self.values = copy.deepcopy(state.values)
+        self.weights = copy.deepcopy(state.weights)
+        
+        for key, disp in state._disp_obj_dict.iteritems():
+            # From saved file, disp_model can not be sent in model obj.
+            # it will be sent as a string here, then converted to model object.
+            if disp.__class__.__name__ == 'str':
+                com_str  = "from sans.models.dispersion_models "
+                com_str += "import %s as disp_func"
+                exec com_str % disp
+                disp_model = disp_func()
             else:
-                self.model_view.Enable()
-        ## set the select all check box to the a given state
-        if hasattr(self, "cb1"):   
-            self.cb1.SetValue(state.cb1)
-     
-        ## reset state of checkbox,textcrtl  and  regular parameters value
-            
-        self._reset_parameters_state(self.orientation_params_disp,
-                                     state.orientation_params_disp)
-        self._reset_parameters_state(self.orientation_params,
-                                     state.orientation_params)
-        self._reset_parameters_state(self.parameters,state.parameters)    
-         ## display dispersion info layer        
-        self.enable_disp.SetValue(state.enable_disp)
-        self.disable_disp.SetValue(state.disable_disp)
-        
-        if hasattr(self, "disp_box"):
-            
-            self.disp_box.SetSelection(state.disp_box) 
-            n= self.disp_box.GetCurrentSelection()
-            dispersity= self.disp_box.GetClientData(n)
-            name= dispersity.__name__     
-
-            self._set_dipers_Param(event=None)
-       
-            if name=="ArrayDispersion":
-                
-                for item in self.disp_cb_dict.keys():
-                    
-                    if hasattr(self.disp_cb_dict[item],"SetValue") :
-                        self.disp_cb_dict[item].SetValue(state.disp_cb_dict[item])
-                        # Create the dispersion objects
-                        from sans.models.dispersion_models import ArrayDispersion
-                        disp_model = ArrayDispersion()
-                        if hasattr(state,"values") and\
-                             self.disp_cb_dict[item].GetValue()==True:
-                            if len(state.values) > 0:
-                                self.values = state.values
-                                self.weights = state.weights
-                                disp_model.set_weights(self.values,
-                                                        state.weights)
-                            else:
-                                self._reset_dispersity()
-                        
-                        self._disp_obj_dict[item] = disp_model
-                        # Set the new model as the dispersion
-                        #object for the selected parameter
-                        self.model.set_dispersion(item, disp_model)
-                    
-                        self.model._persistency_dict[item] = [state.values,
-                                                               state.weights]
-                    
-            else:
-                keys = self.model.getParamList()
-                for item in keys:
-                    if item in self.disp_list and \
-                            not self.model.details.has_key(item):
-                        self.model.details[item]=["",None,None]
-                for k,v in self.state.disp_cb_dict.iteritems():
-                    self.disp_cb_dict = copy.deepcopy(state.disp_cb_dict) 
-                    self.state.disp_cb_dict = copy.deepcopy(state.disp_cb_dict)
-
-        ##plotting range restore    
-        self._reset_plotting_range(state)
-
-        ## smearing info  restore
-        if hasattr(self,"enable_smearer"):
-            ## set smearing value whether or not the data 
-            #contain the smearing info
-            self.enable_smearer.SetValue(state.enable_smearer)
-            self.disable_smearer.SetValue(state.disable_smearer)
-            self.onSmear(event=None)           
-        self.pinhole_smearer.SetValue(state.pinhole_smearer)
-        self.slit_smearer.SetValue(state.slit_smearer)
-        ## we have two more options for smearing
-        if self.pinhole_smearer.GetValue(): self.onPinholeSmear(event=None)
-        elif self.slit_smearer.GetValue(): self.onSlitSmear(event=None)
-       
-        ## reset state of checkbox,textcrtl  and dispersity parameters value
-        self._reset_parameters_state(self.fittable_param,state.fittable_param)
-        self._reset_parameters_state(self.fixed_param,state.fixed_param)
-        
-        ## draw the model with previous parameters value
-        self._onparamEnter_helper()
-        
-        ## reset context menu items
-        self._reset_context_menu()
-    
-        ## set the value of the current state to the state given as parameter
-        self.state = state.clone() 
-        self._draw_model()
-
+                disp_model = disp
+
+            self._disp_obj_dict[key] = disp_model 
+            param_name = key.split('.')[0]
+            # Try to set dispersion only when available
+            # for eg., pass the orient. angles for 1D Cal 
+            try:
+                self.model.set_dispersion(param_name, disp_model)
+                self.model._persistency_dict[key] = \
+                                 [state.values, state.weights]
+            except:
+                pass
+            selection = self._find_polyfunc_selection(disp_model)
+            for list in self.fittable_param:
+                if list[1] == key and list[7] != None:
+                    list[7].SetSelection(selection)
+                    # For the array disp_model, set the values and weights 
+                    if selection == 1:
+                        disp_model.set_weights(self.values[key], 
+                                              self.weights[key])
+                        try:
+                            # Diables all fittable params for array
+                            list[0].SetValue(False)
+                            list[0].Disable()
+                            list[2].Disable()
+                            list[5].Disable()
+                            list[6].Disable()
+                        except:
+                            pass
+            # For array, disable all fixed params
+            if selection == 1:
+                for item in self.fixed_param:
+                    if item[1].split(".")[0] == key.split(".")[0]:
+                        # try it and pass it for the orientation for 1D
+                        try:
+                            item[2].Disable()
+                        except:
+                            pass
+    
+        # Make sure the check box updated when all checked
+        if self.cb1.GetValue():
+            self.select_all_param(None)        
+      
     def _selectDlg(self):
         """
@@ -1545,4 +1297,8 @@
             if item_page[2]!=None:
                 item_page[2].SetValue(item_page_info[2])
+                if item_page[2].__class__.__name__ == "ComboBox":
+                   if self.model.fun_list.has_key(item_page_info[2]):
+                       fun_val = self.model.fun_list[item_page_info[2]]
+                       self.model.setParam(item_page_info[1],fun_val)
             if item_page[3]!=None:
                 ## show or hide text +/-
@@ -1560,17 +1316,38 @@
             if item_page[5]!=None:
                 ## show of hide the text crtl for fitting error
-                if item_page_info[5][0]:
-                    item_page[5].Show(True)
-                    item_page[5].SetValue(item_page_info[5][1])
-                else:
-                    item_page[5].Hide()
-                    
+                item_page[5].Show(item_page_info[5][0])
+                item_page[5].SetValue(item_page_info[5][1])
+                
             if item_page[6]!=None:
                 ## show of hide the text crtl for fitting error
-                if item_page_info[6][0]:
-                    item_page[6].Show(True)
-                    item_page[6].SetValue(item_page_info[6][1])
-                else:
-                    item_page[6].Hide()
+                item_page[6].Show(item_page_info[6][0])
+                item_page[6].SetValue(item_page_info[6][1])
+
+                    
+    def _reset_strparam_state(self, listtorestore, statelist):
+        """
+        Reset the string parameters at the given state
+        """
+        if len(statelist) == 0:
+            return
+
+        listtorestore = copy.deepcopy(statelist)
+        
+        for j in range(len(listtorestore)):
+            item_page = listtorestore[j]
+            item_page_info = statelist[j]
+            ##change the state of the check box for simple parameters
+            
+            if item_page[0] != None:   
+                item_page[0].SetValue(format_number(item_page_info[0], True))
+
+            if item_page[2] != None:
+                param_name = item_page_info[1]
+                value = item_page_info[2]
+                selection = value
+                if self.model.fun_list.has_key(value):
+                    selection = self.model.fun_list[value]
+                item_page[2].SetValue(selection)
+                self.model.setParam(param_name, selection)
                                       
     def _copy_parameters_state(self, listtocopy, statelist):
@@ -1739,9 +1516,11 @@
                     break
     
-    def _draw_model(self):
+    def _draw_model(self, update_chisqr=True):
         """
         Method to draw or refresh a plotted model.
         The method will use the data member from the model page
         to build a call to the fitting perspective manager.
+        
+        :param chisqr: update chisqr value [bool]
         """
         #if self.check_invalid_panel():
@@ -1762,5 +1541,6 @@
                                     toggle_mode_on=toggle_mode_on, 
                                     state = self.state,
-                                    enable2D=self.enable2D)
+                                    enable2D=self.enable2D,
+                                    update_chisqr=update_chisqr)
         
        
@@ -2171,5 +1951,6 @@
             name = str(item[1])
             
-            if string.find(name,".npts") ==-1 and string.find(name,".nsigmas")==-1:      
+            if string.find(name,".npts") ==-1 and \
+                                        string.find(name,".nsigmas")==-1:      
                 ## check model parameters range             
                 param_min= None
@@ -2191,5 +1972,6 @@
                         except:
                             msg = "Wrong Fit parameter range entered "
-                            wx.PostEvent(self.parent.parent, StatusEvent(status = msg))
+                            wx.PostEvent(self.parent.parent, 
+                                         StatusEvent(status = msg))
                             raise ValueError, msg
                         is_modified = True
@@ -2207,5 +1989,6 @@
                         except:
                             msg = "Wrong Fit parameter range entered "
-                            wx.PostEvent(self.parent.parent, StatusEvent(status = msg))
+                            wx.PostEvent(self.parent.parent, 
+                                         StatusEvent(status = msg))
                             raise ValueError, msg
                         is_modified = True
@@ -2216,21 +1999,25 @@
                         msg= "Wrong Fit range entered for parameter "
                         msg+= "name %s of model %s "%(name, self.model.name)
-                        wx.PostEvent(self.parent.parent, StatusEvent(status = msg))
+                        wx.PostEvent(self.parent.parent, 
+                                     StatusEvent(status = msg))
                 
                 if name in self.model.details.keys():   
-                        self.model.details[name][1:3]= param_min,param_max
+                        self.model.details[name][1:3] = param_min, param_max
                         is_modified = True
               
                 else:
-                        self.model.details [name] = ["",param_min,param_max] 
+                        self.model.details [name] = ["", param_min, param_max] 
                         is_modified = True
-            try:     
-                value= float(item[2].GetValue())
-                item[2].SetBackgroundColour("white")
-                # If the value of the parameter has changed,
-                # +update the model and set the is_modified flag
-                if value != self.model.getParam(name) and numpy.isfinite(value):
-                    self.model.setParam(name,value)
-                    is_modified = True   
+            try:   
+                # Check if the textctr is enabled
+                if item[2].IsEnabled():
+                    value= float(item[2].GetValue())
+                    item[2].SetBackgroundColour("white")
+                    # If the value of the parameter has changed,
+                    # +update the model and set the is_modified flag
+                    if value != self.model.getParam(name) and \
+                                                numpy.isfinite(value):
+                        self.model.setParam(name, value)
+                        
             except:
                 item[2].SetBackgroundColour("pink")
@@ -2264,11 +2051,8 @@
         if self.model ==None:
             self.model_disp.Hide()
-            self.disp_box.Hide()
             self.sizer4_4.Clear(True)
             return
 
         if self.enable_disp.GetValue():
-            self.model_disp.Show(True)
-            self.disp_box.Show(True)
             ## layout for model containing no dispersity parameters
             
@@ -2281,7 +2065,4 @@
                 self._on_select_Disp(event=None)
         else:
-            self.model_disp.Hide()
-            self.disp_box.Hide()
-            self.disp_box.SetSelection(0) 
             self.sizer4_4.Clear(True)
             
@@ -2310,10 +2091,10 @@
         self.orientation_params_disp=[]
         
-        self.model_disp.Hide()
-        self.disp_box.Hide()
         self.sizer4_4.Clear(True)
         text = "No polydispersity available for this model"
+        text = "No polydispersity available for this model"
         model_disp = wx.StaticText(self, -1, text)
-        self.sizer4_4.Add(model_disp,( iy, ix),(1,1),  wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
+        self.sizer4_4.Add(model_disp,( iy, ix),(1,1),  
+                            wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 10)
         self.sizer4_4.Layout()
         self.sizer4.Layout()
@@ -2335,6 +2116,6 @@
         self.fixed_param=[]
         self.orientation_params_disp=[]
-        self.values=[]
-        self.weights=[]
+        self.values={}
+        self.weights={}
       
         from sans.models.dispersion_models import GaussianDispersion, ArrayDispersion
